<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">


<mapper namespace="com.zipdoc.acs.persistence.dao.ShopOrderDao">
	
	<resultMap id="shopOrderResult" type="com.zipdoc.acs.domain.entity.ShopOrderInfo">
		<id property="order_no" column="ORDER_NO" />
		<result property="sno" column="SNO"/>
		<result property="order_type" column="ORDER_TYPE"/>
		<result property="order_goods_name" column="ORDER_GOODS_NAME"/>
		<result property="order_goods_cnt" column="ORDER_GOODS_CNT"/>
		<result property="total_discount_price" column="TOTAL_DISCOUNT_PRICE"/>
		<result property="total_order_price" column="TOTAL_ORDER_PRICE"/>
		<result property="total_order_goods" column="TOTAL_ORDER_GOODS"/>
		<result property="order_method" column="ORDER_METHOD"/>
		<result property="non_member_email" column="NON_MEMBER_EMAIL"/>
		<result property="bank_account" column="BANK_ACCOUNT"/>
		<result property="bank_sender" column="BANK_SENDER"/>
		<result property="total_delivery_charge" column="TOTAL_DELIVERY_CHARGE"/>
		<result property="create_date" column="CREATE_DATE"/>
		<result property="creater" column="CREATER"/>
		<result property="goods_no" column="GOODS_NO"/>
		<result property="goods_main_img" column="GOODS_MAIN_IMG"/>
		<collection property="shopOrderGoodsList" ofType="ShopOrderGoods">
			<id property="sno" column="G_SNO"/>
			<result property="order_no" column="G_ORDER_NO"/>
			<result property="order_status" column="G_ORDER_STATUS"/>
			<result property="goods_no" column="G_GOODS_NO"/>
			<result property="handle_sno" column="G_HANDLE_SNO"/>
			<result property="handle_mode" column="G_HANDLE_MODE"/>
			<result property="handle_complete_status" column="G_HANDLE_COMPLETE_STATUS"/>
			<result property="goods_code" column="G_GOODS_CODE"/>
			<result property="goods_name" column="G_GOODS_NAME"/>
			<result property="goods_price" column="G_GOODS_PRICE"/>
			<result property="model_name" column="G_MODEL_NAME"/>
			<result property="maker_name" column="G_MAKER_NAME"/>
			<result property="goods_option_value" column="G_GOODS_OPTION_VALUE"/>
			<result property="goods_option_sno" column="G_GOODS_OPTION_SNO"/>
			<result property="goods_option_cnt" column="G_GOODS_OPTION_CNT"/>
			<result property="delivery_price" column="G_DELIVERY_PRICE"/>
			<result property="origin_name" column="G_ORIGIN_NAME"/>
			<result property="category_code" column="G_CATEGORY_CODE"/>
			<result property="invoice_date" column="G_INVOICE_DATE"/>
			<result property="create_date" column="G_CREATE_DATE"/>
			<result property="goods_main_img" column="GOODS_MAIN_IMG"/>
			<result property="option_discount" column="GOODS_DISCOUNT"/>
			<result property="option_discount_purchase" column="GOODS_DISCOUNT_PURCHASE"/>
			<result property="option_discount_price" column="GOODS_DISCOUNT_PRICE"/>
			<result property="option_discount_status" column="GOODS_DISCOUNT_STATUS"/>

		</collection>
	</resultMap>
	
	<select id="selectList" parameterType="map" resultMap="shopOrderResult">
		SELECT
				 O.SNO
				,O.ORDER_NO
				,O.ORDER_TYPE
				,O.ORDER_GOODS_NAME
				,O.ORDER_GOODS_CNT
				,O.TOTAL_DISCOUNT_PRICE
				,O.TOTAL_ORDER_PRICE
				,O.TOTAL_ORDER_GOODS
				,O.ORDER_METHOD
				,O.NON_MEMBER_EMAIL
				,O.BANK_ACCOUNT
				,O.BANK_SENDER
				,O.TOTAL_DELIVERY_CHARGE
				,O.CREATE_DATE
				,O.CREATER
				,G.SNO               AS G_SNO
				,G.ORDER_NO          AS G_ORDER_NO
				,G.ORDER_STATUS      AS G_ORDER_STATUS
				,G.GOODS_NO          AS G_GOODS_NO
				,(SELECT H.HANDLE_MODE FROM T_SHOP_ORDER_HANDLE H WHERE H.ORDER_NO = G.ORDER_NO AND H.ORDER_GOODS_SNO = G.SNO LIMIT 1) AS G_HANDLE_MODE
				,(SELECT H.HANDLE_COMPLETE_STATUS FROM T_SHOP_ORDER_HANDLE H WHERE H.ORDER_NO = G.ORDER_NO AND H.ORDER_GOODS_SNO = G.SNO LIMIT 1) AS G_HANDLE_COMPLETE_STATUS
				,G.GOODS_CODE        AS G_GOODS_CODE
				,(SELECT GOODS_NAME FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS G_GOODS_NAME
				,G.GOODS_NAME        AS G_GOODS_OPTION_VALUE
				,G.GOODS_PRICE       AS G_GOODS_PRICE
				,G.MODEL_NAME        AS G_MODEL_NAME
				,G.MAKER_NAME        AS G_MAKER_NAME
				,G.GOODS_OPTION_SNO  AS G_GOODS_OPTION_SNO
				,IFNULL(G.GOODS_OPTION_CNT, 1)  AS G_GOODS_OPTION_CNT
				,G.DELIVERY_PRICE    AS G_DELIVERY_PRICE
				,G.ORIGIN_NAME       AS G_ORIGIN_NAME
				,G.CATEGORY_CODE     AS G_CATEGORY_CODE
				,G.INVOICE_DATE      AS G_INVOICE_DATE
				,G.CREATE_DATE	     AS G_CREATE_DATE
				,(SELECT GF.FILE_NAME FROM T_SHOP_GOODS SG, T_SHOP_GOODS_FILE GF WHERE SG.GOODS_NO = G.GOODS_NO AND SG.GOODS_NO = GF.GOODS_NO ORDER BY GF.SNO ASC LIMIT 1) AS GOODS_MAIN_IMG
				,(SELECT SG.GOODS_DISCOUNT FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT
			    ,(SELECT SG.GOODS_DISCOUNT_PURCHASE FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT_PURCHASE
			    ,(SELECT SG.GOODS_DISCOUNT_PRICE FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT_PRICE
			    ,(SELECT SG.GOODS_DISCOUNT_STATUS FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT_STATUS

		FROM
		(
			SELECT  O.SNO
					,O.ORDER_NO
					,O.ORDER_TYPE
					,O.ORDER_GOODS_NAME
					,O.ORDER_GOODS_CNT
					,O.TOTAL_DISCOUNT_PRICE
					,O.TOTAL_ORDER_PRICE
					,O.TOTAL_ORDER_GOODS
					,O.ORDER_METHOD
					,O.NON_MEMBER_EMAIL
					,O.BANK_ACCOUNT
					,O.BANK_SENDER
					,O.TOTAL_DELIVERY_CHARGE
					,O.CREATE_DATE
					,O.CREATER
			FROM T_SHOP_ORDER O
			WHERE O.CREATER = #{member_no}
			ORDER BY O.SNO DESC
			LIMIT #{page}, #{limit}
		) O, T_SHOP_ORDER_GOODS G
		WHERE O.ORDER_NO = G.ORDER_NO
		ORDER BY O.SNO DESC
	</select>

	<select id="selectListTotalCount" parameterType="map" resultType="int">
		SELECT COUNT(*)
		FROM T_SHOP_ORDER O
		WHERE O.CREATER = #{member_no}
	</select>

    <select id="selectByOrderNo" parameterType="String" resultType="ShopOrder">
        SELECT
        ORDER_NO
        ,ORDER_TYPE
        ,NON_MEMBER_EMAIL
        ,ORDER_GOODS_NAME
        ,ORDER_GOODS_CNT
        ,TOTAL_DISCOUNT_PRICE
        ,TOTAL_ORDER_PRICE
        ,TOTAL_ORDER_GOODS
        ,ORDER_METHOD
        ,BANK_ACCOUNT
        ,BANK_SENDER
        ,TOTAL_DELIVERY_CHARGE
        ,(SELECT SG.GOODS_NO FROM T_SHOP_ORDER_GOODS OG, T_SHOP_GOODS SG WHERE OG.ORDER_NO = O.ORDER_NO AND OG.GOODS_NO = SG.GOODS_NO ORDER BY OG.SNO ASC LIMIT 1) AS GOODS_NO
        ,(SELECT GF.FILE_NAME FROM T_SHOP_ORDER_GOODS OG, T_SHOP_GOODS SG, T_SHOP_GOODS_FILE GF WHERE OG.ORDER_NO = O.ORDER_NO AND OG.GOODS_NO = SG.GOODS_NO AND SG.GOODS_NO = GF.GOODS_NO ORDER BY OG.SNO ASC, GF.SNO ASC LIMIT 1) AS GOODS_MAIN_IMG
        FROM T_SHOP_ORDER O
        WHERE ORDER_NO = #{order_no}
    </select>

    <insert id="insert" parameterType="ShopOrder">

        INSERT INTO T_SHOP_ORDER (
        SNO
        ,ORDER_NO
        ,ORDER_TYPE
        ,NON_MEMBER_EMAIL
        ,ORDER_GOODS_NAME
        ,ORDER_GOODS_CNT
        ,TOTAL_DISCOUNT_PRICE
        ,TOTAL_ORDER_PRICE
        ,TOTAL_ORDER_GOODS
        ,ORDER_METHOD
        ,PAYMENT_STATUS
        ,BANK_ACCOUNT
        ,BANK_SENDER
        ,BANK_NUMBER
        ,BANK_DATE
        ,TOTAL_DELIVERY_CHARGE
        ,PAYMENT_DATE
        ,CREATE_DATE
        ,UPDATE_DATE
        ,CREATER
        ,UPDATER
        )
        VALUES (
        #{sno}
        ,#{order_no}
        ,#{order_type}
        ,#{non_member_email}
        ,#{order_goods_name}
        ,#{order_goods_cnt}
        ,#{total_discount_price}
        ,#{total_order_price}
        ,#{total_order_goods}
        ,#{order_method}
        ,#{payment_status}
        ,#{bank_account}
        ,#{bank_sender}
        ,#{bank_number}
        ,#{bank_date}
        ,#{total_delivery_charge}
        ,now()
        ,now()
        ,#{update_date}
        ,#{creater}
        ,#{updater}
        )
        <selectKey resultType="long" keyProperty="sno" order="AFTER">
            SELECT LAST_INSERT_ID()
        </selectKey>


    </insert>
    
    <select id="findByIdWithOrderGoods" parameterType="String" resultMap="shopOrderResult">
    	SELECT
				 O.SNO
				,O.ORDER_NO
				,O.ORDER_TYPE
				,O.ORDER_GOODS_NAME
				,O.ORDER_GOODS_CNT
				,O.TOTAL_DISCOUNT_PRICE
				,O.TOTAL_ORDER_PRICE
				,O.TOTAL_ORDER_GOODS
				,O.ORDER_METHOD
				,O.NON_MEMBER_EMAIL
				,O.BANK_ACCOUNT
				,O.BANK_SENDER
				,O.TOTAL_DELIVERY_CHARGE
				,O.CREATE_DATE
				,O.CREATER
				,G.SNO               AS G_SNO
				,G.ORDER_NO          AS G_ORDER_NO
				,G.ORDER_STATUS      AS G_ORDER_STATUS
				,G.GOODS_NO          AS G_GOODS_NO
				,(SELECT H.HANDLE_MODE FROM T_SHOP_ORDER_HANDLE H WHERE H.ORDER_NO = G.ORDER_NO AND H.ORDER_GOODS_SNO = G.SNO LIMIT 1) AS G_HANDLE_MODE
				,(SELECT H.HANDLE_COMPLETE_STATUS FROM T_SHOP_ORDER_HANDLE H WHERE H.ORDER_NO = G.ORDER_NO AND H.ORDER_GOODS_SNO = G.SNO LIMIT 1) AS G_HANDLE_COMPLETE_STATUS
				,G.GOODS_CODE        AS G_GOODS_CODE
				,(SELECT GOODS_NAME FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS G_GOODS_NAME
				,G.GOODS_NAME        AS G_GOODS_OPTION_VALUE
				,G.GOODS_PRICE       AS G_GOODS_PRICE
				,G.MODEL_NAME        AS G_MODEL_NAME
				,G.MAKER_NAME        AS G_MAKER_NAME
				,G.GOODS_OPTION_SNO  AS G_GOODS_OPTION_SNO
				,IFNULL(G.GOODS_OPTION_CNT, 1)  AS G_GOODS_OPTION_CNT
				,G.DELIVERY_PRICE    AS G_DELIVERY_PRICE
				,G.ORIGIN_NAME       AS G_ORIGIN_NAME
				,G.CATEGORY_CODE     AS G_CATEGORY_CODE
				,G.INVOICE_DATE      AS G_INVOICE_DATE
				,G.CREATE_DATE	     AS G_CREATE_DATE
				,(SELECT GF.FILE_NAME FROM T_SHOP_GOODS SG, T_SHOP_GOODS_FILE GF WHERE SG.GOODS_NO = G.GOODS_NO AND SG.GOODS_NO = GF.GOODS_NO ORDER BY GF.SNO ASC LIMIT 1) AS GOODS_MAIN_IMG
				,(SELECT SG.GOODS_DISCOUNT FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT
			    ,(SELECT SG.GOODS_DISCOUNT_PURCHASE FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT_PURCHASE
			    ,(SELECT SG.GOODS_DISCOUNT_PRICE FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT_PRICE
			    ,(SELECT SG.GOODS_DISCOUNT_STATUS FROM T_SHOP_GOODS SG WHERE SG.GOODS_NO = G.GOODS_NO LIMIT 1) AS GOODS_DISCOUNT_STATUS
		FROM T_SHOP_ORDER O, T_SHOP_ORDER_GOODS G
		WHERE O.ORDER_NO = #{order_no}
		  AND O.ORDER_NO = G.ORDER_NO
    </select>
    
    <select id="findById" parameterType="String" resultType="ShopOrder">
		SELECT
			 ORDER_NO
			,ORDER_TYPE
			,NON_MEMBER_EMAIL
			,ORDER_GOODS_NAME
			,ORDER_GOODS_CNT
			,TOTAL_DISCOUNT_PRICE
			,TOTAL_ORDER_PRICE
			,TOTAL_ORDER_GOODS
			,ORDER_METHOD
			,BANK_ACCOUNT
			,BANK_SENDER
			,TOTAL_DELIVERY_CHARGE
			,(SELECT SG.GOODS_NO FROM T_SHOP_ORDER_GOODS OG, T_SHOP_GOODS SG WHERE OG.ORDER_NO = O.ORDER_NO AND OG.GOODS_NO = SG.GOODS_NO ORDER BY OG.SNO ASC LIMIT 1) AS GOODS_NO
			,(SELECT GF.FILE_NAME FROM T_SHOP_ORDER_GOODS OG, T_SHOP_GOODS SG, T_SHOP_GOODS_FILE GF WHERE OG.ORDER_NO = O.ORDER_NO AND OG.GOODS_NO = SG.GOODS_NO AND SG.GOODS_NO = GF.GOODS_NO ORDER BY OG.SNO ASC, GF.SNO ASC LIMIT 1) AS GOODS_MAIN_IMG
		FROM T_SHOP_ORDER O
			WHERE ORDER_NO = #{order_no}
	</select>

</mapper>